/*
 ============================================================================
 Project     : Distance Translocation Algorithm
 Author      : Lucas Angelo Silveira
 Universidade de Brasilia (UnB) - Brazil
 Group of Theory of Computation
 Version     : 1.0
 
 Last Modified On: May 09, 2015.
 ============================================================================
 */
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <math.h>
#include "Additionaldata.c"

 int capping1= 0; // boolean to decide if the genomes need to be capped
int size_compDistances;
int numberOfCycles;//variables of count the amount of cycles black

//initialize variables
void S_genomeLength(){

    size_compDistances=0;
    numberOfCycles = 0;
}//end of the S_genomeLength



 int * copiar_cromossomo(int i, int j, int status){
        int k=0;
	int *array=(int *) calloc (j+1, sizeof (int));
	if(status==1)//genome A
	{
        for(;k<=j;k++)
		{

			array[k]=GENOMA_A[i][k];
				
		}//fim for
	}//fim if
     
	else//genome B
	{
		for(;k<=j;k++)
		{

			array[k]=GENOMA_B[i][k];
				
		}//end for
		
	}//end else

return array; 	

}// end of the functions



int abstractGene(int gene, int left) {

	if ((gene <= 0 && left==0) || (gene >= 0 && left==1)) {
	return 2 * abs(gene);
        }
	return 2 * abs(gene) - 1;
    }



 int * parseAdjacencies(int status, int entrada[],int size)
{	int i;
	int j;
    int geneNumberLeft;
    int geneNumberRight;
	int length;
        int * genomeAdjacencies =(int *) calloc (2 * qtd_genes + 1, sizeof (int));
        int *estatus;
         if(status==1) 
           estatus=status_A(entrada, size);
         else
           estatus=status_B(entrada, size);
       
   
	if(status==1)//genoma A
       {

	for ( i = 0; i < qtd_cromossomo; ++i) {
	           
	    length =estatus[i];
       
        geneNumberLeft =abstractGene(GENOMA_A[i][0], 0);// 0 represents the Boolean value false
        geneNumberRight = abstractGene(GENOMA_A[i][estatus[i]-1], 1); // Right telomere is left in adjacency:
        
            if (GENOMA_A[i][length]==1) {
                genomeAdjacencies[geneNumberLeft] = geneNumberRight;
                genomeAdjacencies[geneNumberRight] = geneNumberLeft;
                // can already save telomere entries
            } else {
                genomeAdjacencies[geneNumberLeft] = geneNumberLeft;
                genomeAdjacencies[geneNumberRight] = geneNumberRight;
            }

            for (j= 1; j < estatus[i]; ++j) {
                geneNumberLeft = abstractGene(GENOMA_A[i][j - 1], 1);//1 true
                geneNumberRight = abstractGene(GENOMA_A[i][j], 0);//0 false
               // printf(" valor de geneNumberLeft %d e geneNumberRight %d \n",geneNumberLeft,geneNumberRight);
                genomeAdjacencies[geneNumberLeft] = geneNumberRight; // save
                genomeAdjacencies[geneNumberRight] = geneNumberLeft;
            }
	
        }
         
    }//fim do status 1
  else
  {	 
       for ( i = 0; i < qtd_cromossomo; ++i) {
	       length =estatus[i];
            geneNumberLeft =abstractGene(GENOMA_B[i][0], 0);// 0 represents the Boolean value false
            geneNumberRight = abstractGene(GENOMA_B[i][estatus[i]-1], 1); // Right telomere is left in adjacency:
            if (GENOMA_B[i][length]==1)
            {
		        genomeAdjacencies[geneNumberLeft] = geneNumberRight;
                genomeAdjacencies[geneNumberRight] = geneNumberLeft;
                
            }
            else
            {
                genomeAdjacencies[geneNumberLeft] = geneNumberLeft;
                genomeAdjacencies[geneNumberRight] = geneNumberRight;
            }//fim else

            for (j= 1; j < estatus[i]; ++j) {
                geneNumberLeft = abstractGene(GENOMA_B[i][j - 1], 1);//1 true
                geneNumberRight = abstractGene(GENOMA_B[i][j], 0);//0 false

                genomeAdjacencies[geneNumberLeft] = geneNumberRight; // save
                genomeAdjacencies[geneNumberRight] = geneNumberLeft;
            }// end for
	
        }//end for
  	
  				
   }//else for status 2
	
 free(estatus);
return genomeAdjacencies;

}//end of the parseAdjacencies

// Calculates the number of paths and cycles in the graph
int * calculatePathsAndCycles(int entrada[], int entrada2[], int size){
    size_compDistances=0;
    int compDistances[2 * qtd_genes + 1];
	int * adjacenciesGenome1=parseAdjacencies(1,entrada, size);
    int * adjacenciesGenome2=parseAdjacencies(2, entrada2, size);
    int * belongToEvenP=(int *) calloc (2 * qtd_genes + 1, sizeof (int));
    int edgesCount = 0;
    int visited[2 * qtd_genes + 1];// represents boolean values
    int numberOfOddPaths = 0;
	numberOfCycles=0;//global variable 
    int i;
	for(i=0;i<(2 * qtd_genes + 1);i++)
		visited[i]=0;
    
    for (i = 1; i < (2 * qtd_genes + 1); ++i) {
        
        if (!visited[i]) {
            visited[i] = 1; // i was now visited
            int choose1stGenome = 0; // chooses target genome of current edge
            int extremityPath1 = i;
            int extremityPath2 = i;
            int nextExtremityPath1 = 0;
            int nextExtremityPath2 = 0;
            ++edgesCount;
            nextExtremityPath1 = adjacenciesGenome1[i]; // get next extremities
            nextExtremityPath2 = adjacenciesGenome2[i];
            
             int secondCap = 0;
            
            while ((!visited[nextExtremityPath1]) && (nextExtremityPath1 != extremityPath1)) {
                visited[nextExtremityPath1] = 1;
                ++edgesCount;
                extremityPath1 = nextExtremityPath1;
                
                
                if (choose1stGenome) { // chooses target genome of current edge
                    nextExtremityPath1 = adjacenciesGenome1[extremityPath1];
                    choose1stGenome = 0;//representing false
                }
                else
                {
                    nextExtremityPath1 = adjacenciesGenome2[extremityPath1];
                    choose1stGenome = 1;//representing true
                }
            } // path1 is finished, now walk along path2 if path1 was not a cycle
           
            
            if ((extremityPath2 == nextExtremityPath1) && (extremityPath1 != extremityPath2)) {
                 // check if path1 is a cycle
                compDistances[size_compDistances]=(edgesCount - 2) / 2;
                size_compDistances++;
                ++numberOfCycles;
            
            }//end of the if
            
            else
            {
                choose1stGenome = 1;//representing true
                while (nextExtremityPath2 != extremityPath2) {
                    
                    visited[nextExtremityPath2] = 1; // can't be circular anymore
                    ++edgesCount;
                    extremityPath2 = nextExtremityPath2;
                    
                    if (choose1stGenome)
                    {
                        nextExtremityPath2 = adjacenciesGenome1[extremityPath2];
                        choose1stGenome = 0;//representing false
                        
                    }
                    
                    else
                    {
                        nextExtremityPath2 = adjacenciesGenome2[extremityPath2];
                        choose1stGenome = 1;//representing true
                    }
                }//end while
                
                if (edgesCount % 2 == 0)
                {
                    compDistances[size_compDistances]=edgesCount / 2;
                    size_compDistances++;
                    // update array saving true if an an extremity belongs to an even path
                    belongToEvenP[extremityPath2] = 1;//representing true
                                        
                    if (choose1stGenome)
                    {
                        nextExtremityPath2 = adjacenciesGenome1[extremityPath2];
                        choose1stGenome = 0;//representing false
                    }//end if
                    
                    else
                    {
                        nextExtremityPath2 = adjacenciesGenome2[extremityPath2];
                        choose1stGenome = 1;//representing true
                    }//end else
                    
                    secondCap = extremityPath2;
                    while (nextExtremityPath2 != extremityPath2) {

                        extremityPath2 = nextExtremityPath2;
                        belongToEvenP[extremityPath2] = 1;//representing true
                        
                        if (choose1stGenome)
                        {
                            nextExtremityPath2 = adjacenciesGenome1[extremityPath2];
                            choose1stGenome = 0;//representing false
                        }
                        
                        else
                        {
                            nextExtremityPath2 = adjacenciesGenome2[extremityPath2];
                            choose1stGenome =1;//representing true
                        }
                    }//end while
                    
                    // Capping for even paths
                    if (capping1)
                    {
                        int firstGenome = choose1stGenome;
                        firstGenome=firstGenome;
                       
                    }
                }//end if
                else
                {
                    
                    compDistances[size_compDistances]=(edgesCount - 1) / 2;
                    size_compDistances++;
                    ++numberOfOddPaths;
                    // Capping for odd paths
                    if (capping1)
                    {
                         int firstGenome = choose1stGenome;
                        firstGenome=firstGenome;
                    }//end if
                }//end else
            }//end else
            edgesCount = 0;
        }//end if, the first if what appear
    }//fim do for
	
return belongToEvenP;
}//end




void adjacencygraph(int entrada[],int entrada2[], int size){
    S_genomeLength();
	 parseAdjacencies(2,entrada2, size);
	

}

