
/*
 ============================================================================
 Project     :  Synthetic Genomes Algorithm
 Author      : Lucas Angelo Silveira
               Universidade de Brasilia (UnB) - Brazil
               Group of Theory of Computation
 Version     : 1.0
 
 Last Modified On: January 24, 2015.
 ============================================================================
 */



#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <math.h>
#include "genomes.h"


int *genomeA;
int * Store;
int * indices_cromossomos;


//save genome A and B 
void Save(int total, int genomeB[])
{

    
    char *name_file = "outgenome.txt";
    FILE *filePointer;
    int i=0;
    
    if ((filePointer = fopen(name_file,"w")) == NULL){
        printf("Output file could not be opened\n");
    }
    else{
         fprintf(filePointer,"%d\n", total-1);
        for(i=0; i<total-1; i++){
            
                fprintf(filePointer,"%d\n",genomeA[i]);
            
        }
        
        fprintf(filePointer,"%d \n",total-1);
        for(i=0; i<total-1; i++){
            if(i<total-2)
                fprintf(filePointer,"%d\n",genomeB[i]);
            else
                fprintf(filePointer,"%d",genomeB[i]);
        }
        
    }
    fclose(filePointer);
  
}

//reverse a strip from i until ii
void reversal(int i, int ii,int total){
   int * array=(int *) calloc (total, sizeof (int));
    int w;
    int m=i;
    for (w =ii; w>=i; w--) {  
        array[m] = genomeA[w];
         m++;  
    }


   for(w=0; w < i;w++)
    {
     array[w]=genomeA[w];
    }

   for(w = ii+1; w < total; w++)
   {
     array[w]=genomeA[w];
    }
  
  for(i=0;i<total-1;i++)
  {
	genomeA[i]=array[i];	   
  }
    

}


//Counting the number of genes in each chromosome of genome A
void Count_genes_chromo(int total)
{
    int i;
    int cont=0;
    Store[0]=0;
    for(i=0; i<total-1; i++)
	{
        if(genomeA[i]==0)
        {
            cont++;
            Store[cont]=0;
        
        
        }
        else
		{
			Store[cont]=Store[cont]+1;
		}//end else
        
        
	}//end for
}

//apply reversal on a random chromosome of A
void apply_reversal(int cromossomo, int Store[], int total){	

    
	int faixa1=(rand() % (Store[cromossomo]-1));
	int faixa2=(rand() % (Store[cromossomo]-1));
	if( faixa1==0 || faixa2==0)
	{
		if(faixa1==0 )
			faixa1=1;
		
		if(faixa2==0)
			faixa2=1;	
	}
        if(cromossomo !=0)
	{
		 int j;
		  for(j=0; j<cromossomo;j++)
		   {
		   	faixa1=Store[j]+faixa1;
		   	faixa2=Store[j]+faixa2;
		   }
		faixa1=faixa1+cromossomo;
		faixa2=faixa2+cromossomo;			
	}

	if(faixa1>faixa2)
	{
		int aux=faixa1;
		faixa1=faixa2;
		faixa2=aux;	
	}	
	
	//printf("faixa1 %d faixa2 %d\n", faixa1, faixa2);
	if(faixa1!=faixa2 && faixa1<total-1 && faixa2<total-1)
    {
       // printf("faixa1 %d faixa2 %d \n", faixa1, faixa2);
        reversal(faixa1, faixa2, total);
        
        
    }
}

void indice_chromosome(int total){
	
	int cont=0;
	int aux=1;
	int i;
	indices_cromossomos[0]=0;
	for( i=0; i< total-1;i++)
	{
		if(i==total-2)
		    indices_cromossomos[aux]=cont;		
		if(genomeA[i]==0)
		{
			indices_cromossomos[aux]=cont-1;
			aux++;
			indices_cromossomos[aux]=cont+1;
			aux++;			
		}
		cont++;
	}

}

//check that the genome is cotail
int is_cotail(int entrada[],int entrada2[],int size, int sizeB)
{
    int i=0;

    if (size !=sizeB) {
        
        return 0;
    }
    
    int conjuntoA[size];
    int conjuntoB[size];
    
    
    for (; i<size; i++) {
        
        conjuntoA[i]=0;
        conjuntoB[i]=0;
    }
    
    conjuntoA[abs(entrada[0])]=entrada[0];
    conjuntoB[abs(entrada2[0])]=entrada2[0];
    
    
    for (i=1; i<size; i++) {
        
        
        if(i+1 <size && entrada[i+1]==0 )
            conjuntoA[abs(entrada[i])]= -1* entrada[i];
        
        else  if(i+1==size)
            conjuntoA[abs(entrada[i])]=-1*entrada[i];
        
        else if(i>1 && entrada[i-1]==0)
            conjuntoA[abs(entrada[i])]=entrada[i];
        
        else
        {
            if (entrada[i]==0 && conjuntoA[i]==0) {
                conjuntoA[i]=0;
            }
            conjuntoA[abs(entrada[i])]=0;
            
            
        }
        
        
        if(i+1 <size && entrada2[i+1]==0 )
        {
            
            conjuntoB[abs(entrada2[i])]= -1* entrada2[i];
            
            
        }
        else if(i+1==size)
            conjuntoB[abs(entrada2[i])]=-1*entrada2[i];
        
        else if(i>1 && entrada2[i-1]==0)
            conjuntoB[abs(entrada2[i])]=entrada2[i];
        else
        {   if(entrada2[i]==0 && conjuntoB[i]==0)
            conjuntoB[i]=0;
        else
            conjuntoB[abs(entrada2[i])]=0;
        }
    }//fim do for
    
    
    for (i=0; i<size; i++)
    {
        if(conjuntoA[i]!=conjuntoB[i])
            return 0;
    }
    i=0;
    int conta_cromossomo=0;
    for (; i<size; i++) {
        
        if (entrada[i]==0)
            conta_cromossomo++;
        
    }//fim for
    
    return 1;
}//fim da funcao




//I applied only Prefix-prefix translocation
void apply_translocation(int total, int qtd_cromo, int Store[]){
    
  
    int k=0;
    int i,a;
    int recebe, recebe1;
    int crom1=0;
	int crom2=0;
    int j;
	while(crom1== crom2)	
	{	crom1=(rand() % qtd_cromo);
		crom2=(rand() % qtd_cromo);
	} 
	if(crom1>crom2)
	{
		int aux=crom1;
		crom1=crom2;
		crom2=aux;
	}
  
	int faixa1=(rand() % (Store[crom1]-1));
	int faixa2=(rand() % (Store[crom2]-1));

 
    for(j=0; j<crom1;j++)
		faixa1=Store[j]+faixa1;
	        
	
	for(j=0; j<crom2;j++)
	        faixa2=Store[j]+faixa2;
	
	faixa1=faixa1+crom1;

	faixa2=faixa2+crom2;
    
    if(faixa1==0)
        faixa1=2;
    
	if(faixa1>0 && genomeA[faixa1-1]==0)
		faixa1=faixa1+1;


	if(faixa2>0 && genomeA[faixa2-1]==0)
        faixa2=faixa2+1;
    a=faixa1;
    for (j=faixa1+1; j<total-1; j++) {
        
        if (genomeA[j]==0) {
            break;
        }
        
        a=j;
       
    }
    
         
    for (i=faixa2; i<total-1; i++) {
        if (genomeA[i]==0) {
            k=i;
            break;
        }
        
        k=i;
    }
    
    if (k+1<total-1) {
        
        recebe1=genomeA[k-1];
    }
    else
        recebe1=genomeA[k];    
    recebe=genomeA[faixa2];
    if (k+1<total-1) {
        reversal(a+1, k-1, total);
    }
    else
        reversal(a+1, k, total);
   
    
    for (i=0; i<total-1; i++) {
        if (genomeA[i]==recebe) {
            break;
        }
    }
    

     reversal(faixa1, i, total);
   
  
    for (i=0; i<total-1; i++) {
        if (genomeA[i]==recebe1) {
            k=i;
            break;
        }
        
    }
    
    int contador=0;
    for (i=k; i<total-1; i++) {
        if (genomeA[i]==0) {
            contador++;
            
            if (contador==crom2) {
                break;
            }
            
        }
        
    }
    
    if (i==total-1) {
        i=total-2;
    }
    reversal(k+1, i, total);
  
   
   Count_genes_chromo( total);
    
}



// applying reversal and translocation about genome identity
void Built_A(int total, int qtd_cromo, int Store[], int genomeB[]){
	int i,j, cromossomo, reversal, translocacao;
	int * auxiliar=(int *) calloc (total, sizeof (int));
    
    for (i=0; i<total-1; i++) {
        auxiliar[i]=genomeA[i];
    }
 
        for(i=0; i<total-1; i++)
        {	
            cromossomo = (rand() % qtd_cromo); //de 0 a n-1
            reversal=(rand() % 2);
            
        
            if(reversal)
            {
                 Count_genes_chromo( total);
                apply_reversal(cromossomo, Store, total);
                if (is_cotail(genomeA,genomeB,total-1, total-1))
                {
                    
                    for (j=0; j<total-1; j++) {
                    
                        auxiliar[j]=genomeA[j];
                    }
                    
                }
                else
                {
                    for (j=0; j<total-1; j++) {
                        genomeA[j]=auxiliar[j];
                    }
                    
                    
                
                }
                
                

            }
               
            translocacao=(rand() % 2);
         
            if(translocacao)
            {
                 Count_genes_chromo( total);
                apply_translocation( total,qtd_cromo, Store);
                if (is_cotail(genomeA,genomeB,total-1, total-1))
                {
                    
                    for (j=0; j<total-1; j++) {
                        
                        // printf("%d ", genomeA[j]);
                        auxiliar[j]=genomeA[j];
                    }
                    
                }
                else
                {
                    for (j=0; j<total-1; j++) {
                        genomeA[j]=auxiliar[j];
                    }
                    
                }

            }//end is
            
       }//end for

}





//gera genoma identidade
//First parameter is qtd of chromosomes
//Secont qtd of genes
//Third parameter, if 1 for built signed genomes and 0 for unsigend genomes
void Genome_identity(int qtd_cromo, int qtd_genes, int flag)
{	
	int i;
    int cont=0;
    int clone=qtd_cromo;
    int alimenta=0;
	int j=0;
    Store=(int *) calloc (qtd_cromo, sizeof (int));
    indices_cromossomos=(int *) calloc (2*qtd_cromo, sizeof (int));
	int * genomeB=(int *) calloc ((qtd_genes+qtd_cromo)-1, sizeof (int));
	int alimenta_cromossomos=(int)qtd_genes/qtd_cromo;
        int total=qtd_genes+qtd_cromo;
	for(i=0; i<total-1; i++)
	{
		if(clone-1!=0 && cont==alimenta_cromossomos)
		{	genomeB[i]=0;
	    		cont=0;	
			clone--;
            j++;
		}
		else
		{
		
			alimenta++;
			genomeB[i]=alimenta;
			cont++;
			Store[j]=Store[j]+1;		
		}//end else
        
        
	}//end for
    
	genomeA=(int *) calloc (total-1, sizeof (int));
    for(i=0; i<total-1; i++)
	{	
		genomeA[i]=genomeB[i];
	}
    
    

    
	Built_A(total, qtd_cromo, Store, genomeB);
    
    if (flag) {
        for (i=0; i< total -1; i++)
        {
            cont=(rand() % 2);
            if (i!=0 &&i< total-2 && genomeA[i+1]!=0 && genomeA[i-1]!=0&& cont) {
                genomeA[i]=genomeA[i]*-1;
            }
        }
    }
    for(i=0;i<total-1;i++)
    {
        
    }	
    Save(total, genomeB);
}		


	
